Index: dll/win32/shdocvw/client.c
===================================================================
--- dll/win32/shdocvw/client.c	(Revision 31635)
+++ dll/win32/shdocvw/client.c	(Arbeitskopie)
@@ -13,19 +13,23 @@
  *
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
  */
 
+#include <stdio.h>
+
 #include "wine/debug.h"
 #include "shdocvw.h"
+#include "mshtmdid.h"
+#include "idispids.h"
 
 WINE_DEFAULT_DEBUG_CHANNEL(shdocvw);
 
-#define CLIENTSITE_THIS(iface) DEFINE_THIS(WebBrowser, OleClientSite, iface)
+#define CLIENTSITE_THIS(iface) DEFINE_THIS(DocHost, OleClientSite, iface)
 
 static HRESULT WINAPI ClientSite_QueryInterface(IOleClientSite *iface, REFIID riid, void **ppv)
 {
-    WebBrowser *This = CLIENTSITE_THIS(iface);
+    DocHost *This = CLIENTSITE_THIS(iface);
 
     *ppv = NULL;
 
@@ -50,10 +54,19 @@
     }else if(IsEqualGUID(&IID_IOleDocumentSite, riid)) {
         TRACE("(%p)->(IID_IOleDocumentSite %p)\n", This, ppv);
         *ppv = DOCSITE(This);
+    }else if(IsEqualGUID(&IID_IOleCommandTarget, riid)) {
+        TRACE("(%p)->(IID_IOleCommandTarget %p)\n", This, ppv);
+        *ppv = OLECMD(This);
+    }else if(IsEqualGUID(&IID_IDispatch, riid)) {
+        TRACE("(%p)->(IID_IDispatch %p)\n", This, ppv);
+        *ppv = CLDISP(This);
+    }else if(IsEqualGUID(&IID_IServiceProvider, riid)) {
+        TRACE("(%p)->(IID_IServiceProvider %p)\n", This, ppv);
+        *ppv = SERVPROV(This);
     }
 
     if(*ppv) {
-        IWebBrowser2_AddRef(WEBBROWSER(This));
+        IOleClientSite_AddRef(CLIENTSITE(This));
         return S_OK;
     }
 
@@ -64,19 +77,19 @@
 
 static ULONG WINAPI ClientSite_AddRef(IOleClientSite *iface)
 {
-    WebBrowser *This = CLIENTSITE_THIS(iface);
-    return IWebBrowser2_AddRef(WEBBROWSER(This));
+    DocHost *This = CLIENTSITE_THIS(iface);
+    return IDispatch_AddRef(This->disp);
 }
 
 static ULONG WINAPI ClientSite_Release(IOleClientSite *iface)
 {
-    WebBrowser *This = CLIENTSITE_THIS(iface);
-    return IWebBrowser2_Release(WEBBROWSER(This));
+    DocHost *This = CLIENTSITE_THIS(iface);
+    return IDispatch_Release(This->disp);
 }
 
 static HRESULT WINAPI ClientSite_SaveObject(IOleClientSite *iface)
 {
-    WebBrowser *This = CLIENTSITE_THIS(iface);
+    DocHost *This = CLIENTSITE_THIS(iface);
     FIXME("(%p)\n", This);
     return E_NOTIMPL;
 }
@@ -84,35 +97,35 @@
 static HRESULT WINAPI ClientSite_GetMoniker(IOleClientSite *iface, DWORD dwAssign,
                                             DWORD dwWhichMoniker, IMoniker **ppmk)
 {
-    WebBrowser *This = CLIENTSITE_THIS(iface);
-    FIXME("(%p)->(%ld %ld %p)\n", This, dwAssign, dwWhichMoniker, ppmk);
+    DocHost *This = CLIENTSITE_THIS(iface);
+    FIXME("(%p)->(%d %d %p)\n", This, dwAssign, dwWhichMoniker, ppmk);
     return E_NOTIMPL;
 }
 
 static HRESULT WINAPI ClientSite_GetContainer(IOleClientSite *iface, IOleContainer **ppContainer)
 {
-    WebBrowser *This = CLIENTSITE_THIS(iface);
+    DocHost *This = CLIENTSITE_THIS(iface);
     FIXME("(%p)->(%p)\n", This, ppContainer);
     return E_NOTIMPL;
 }
 
 static HRESULT WINAPI ClientSite_ShowObject(IOleClientSite *iface)
 {
-    WebBrowser *This = CLIENTSITE_THIS(iface);
+    DocHost *This = CLIENTSITE_THIS(iface);
     FIXME("(%p)\n", This);
     return E_NOTIMPL;
 }
 
 static HRESULT WINAPI ClientSite_OnShowWindow(IOleClientSite *iface, BOOL fShow)
 {
-    WebBrowser *This = CLIENTSITE_THIS(iface);
+    DocHost *This = CLIENTSITE_THIS(iface);
     FIXME("(%p)->(%x)\n", This, fShow);
     return E_NOTIMPL;
 }
 
 static HRESULT WINAPI ClientSite_RequestNewObjectLayout(IOleClientSite *iface)
 {
-    WebBrowser *This = CLIENTSITE_THIS(iface);
+    DocHost *This = CLIENTSITE_THIS(iface);
     FIXME("(%p)\n", This);
     return E_NOTIMPL;
 }
@@ -131,46 +144,46 @@
     ClientSite_RequestNewObjectLayout
 };
 
-#define INPLACESITE_THIS(iface) DEFINE_THIS(WebBrowser, OleInPlaceSite, iface)
+#define INPLACESITE_THIS(iface) DEFINE_THIS(DocHost, OleInPlaceSite, iface)
 
 static HRESULT WINAPI InPlaceSite_QueryInterface(IOleInPlaceSite *iface, REFIID riid, void **ppv)
 {
-    WebBrowser *This = INPLACESITE_THIS(iface);
+    DocHost *This = INPLACESITE_THIS(iface);
     return IOleClientSite_QueryInterface(CLIENTSITE(This), riid, ppv);
 }
 
 static ULONG WINAPI InPlaceSite_AddRef(IOleInPlaceSite *iface)
 {
-    WebBrowser *This = INPLACESITE_THIS(iface);
+    DocHost *This = INPLACESITE_THIS(iface);
     return IOleClientSite_AddRef(CLIENTSITE(This));
 }
 
 static ULONG WINAPI InPlaceSite_Release(IOleInPlaceSite *iface)
 {
-    WebBrowser *This = INPLACESITE_THIS(iface);
+    DocHost *This = INPLACESITE_THIS(iface);
     return IOleClientSite_Release(CLIENTSITE(This));
 }
 
 static HRESULT WINAPI InPlaceSite_GetWindow(IOleInPlaceSite *iface, HWND *phwnd)
 {
-    WebBrowser *This = INPLACESITE_THIS(iface);
+    DocHost *This = INPLACESITE_THIS(iface);
 
     TRACE("(%p)->(%p)\n", This, phwnd);
 
-    *phwnd = This->doc_view_hwnd;
+    *phwnd = This->hwnd;
     return S_OK;
 }
 
 static HRESULT WINAPI InPlaceSite_ContextSensitiveHelp(IOleInPlaceSite *iface, BOOL fEnterMode)
 {
-    WebBrowser *This = INPLACESITE_THIS(iface);
+    DocHost *This = INPLACESITE_THIS(iface);
     FIXME("(%p)->(%x)\n", This, fEnterMode);
     return E_NOTIMPL;
 }
 
 static HRESULT WINAPI InPlaceSite_CanInPlaceActivate(IOleInPlaceSite *iface)
 {
-    WebBrowser *This = INPLACESITE_THIS(iface);
+    DocHost *This = INPLACESITE_THIS(iface);
 
     TRACE("(%p)\n", This);
 
@@ -180,7 +193,7 @@
 
 static HRESULT WINAPI InPlaceSite_OnInPlaceActivate(IOleInPlaceSite *iface)
 {
-    WebBrowser *This = INPLACESITE_THIS(iface);
+    DocHost *This = INPLACESITE_THIS(iface);
 
     TRACE("(%p)\n", This);
 
@@ -190,7 +203,7 @@
 
 static HRESULT WINAPI InPlaceSite_OnUIActivate(IOleInPlaceSite *iface)
 {
-    WebBrowser *This = INPLACESITE_THIS(iface);
+    DocHost *This = INPLACESITE_THIS(iface);
     FIXME("(%p)\n", This);
     return E_NOTIMPL;
 }
@@ -199,20 +212,21 @@
         IOleInPlaceFrame **ppFrame, IOleInPlaceUIWindow **ppDoc, LPRECT lprcPosRect,
         LPRECT lprcClipRect, LPOLEINPLACEFRAMEINFO lpFrameInfo)
 {
-    WebBrowser *This = INPLACESITE_THIS(iface);
+    DocHost *This = INPLACESITE_THIS(iface);
 
     TRACE("(%p)->(%p %p %p %p %p)\n", This, ppFrame, ppDoc, lprcPosRect,
           lprcClipRect, lpFrameInfo);
 
+    IOleInPlaceFrame_AddRef(INPLACEFRAME(This));
     *ppFrame = INPLACEFRAME(This);
     *ppDoc = NULL;
 
-    GetClientRect(This->doc_view_hwnd, lprcPosRect);
+    GetClientRect(This->hwnd, lprcPosRect);
     memcpy(lprcClipRect, lprcPosRect, sizeof(RECT));
 
     lpFrameInfo->cb = sizeof(*lpFrameInfo);
     lpFrameInfo->fMDIApp = FALSE;
-    lpFrameInfo->hwndFrame = This->shell_embedding_hwnd;
+    lpFrameInfo->hwndFrame = This->frame_hwnd;
     lpFrameInfo->haccel = NULL;
     lpFrameInfo->cAccelEntries = 0; /* FIXME: should be 5 */
 
@@ -221,35 +235,38 @@
 
 static HRESULT WINAPI InPlaceSite_Scroll(IOleInPlaceSite *iface, SIZE scrollExtent)
 {
-    WebBrowser *This = INPLACESITE_THIS(iface);
+    DocHost *This = INPLACESITE_THIS(iface);
     FIXME("(%p)->({%ld %ld})\n", This, scrollExtent.cx, scrollExtent.cy);
     return E_NOTIMPL;
 }
 
 static HRESULT WINAPI InPlaceSite_OnUIDeactivate(IOleInPlaceSite *iface, BOOL fUndoable)
 {
-    WebBrowser *This = INPLACESITE_THIS(iface);
+    DocHost *This = INPLACESITE_THIS(iface);
     FIXME("(%p)->(%x)\n", This, fUndoable);
     return E_NOTIMPL;
 }
 
 static HRESULT WINAPI InPlaceSite_OnInPlaceDeactivate(IOleInPlaceSite *iface)
 {
-    WebBrowser *This = INPLACESITE_THIS(iface);
-    FIXME("(%p)\n", This);
-    return E_NOTIMPL;
+    DocHost *This = INPLACESITE_THIS(iface);
+
+    TRACE("(%p)\n", This);
+
+    /* Nothing to do here */
+    return S_OK;
 }
 
 static HRESULT WINAPI InPlaceSite_DiscardUndoState(IOleInPlaceSite *iface)
 {
-    WebBrowser *This = INPLACESITE_THIS(iface);
+    DocHost *This = INPLACESITE_THIS(iface);
     FIXME("(%p)\n", This);
     return E_NOTIMPL;
 }
 
 static HRESULT WINAPI InPlaceSite_DeactivateAndUndo(IOleInPlaceSite *iface)
 {
-    WebBrowser *This = INPLACESITE_THIS(iface);
+    DocHost *This = INPLACESITE_THIS(iface);
     FIXME("(%p)\n", This);
     return E_NOTIMPL;
 }
@@ -257,7 +274,7 @@
 static HRESULT WINAPI InPlaceSite_OnPosRectChange(IOleInPlaceSite *iface,
                                                   LPCRECT lprcPosRect)
 {
-    WebBrowser *This = INPLACESITE_THIS(iface);
+    DocHost *This = INPLACESITE_THIS(iface);
     FIXME("(%p)->(%p)\n", This, lprcPosRect);
     return E_NOTIMPL;
 }
@@ -282,31 +299,31 @@
     InPlaceSite_OnPosRectChange
 };
 
-#define DOCSITE_THIS(iface) DEFINE_THIS(WebBrowser, OleDocumentSite, iface)
+#define DOCSITE_THIS(iface) DEFINE_THIS(DocHost, OleDocumentSite, iface)
 
 static HRESULT WINAPI OleDocumentSite_QueryInterface(IOleDocumentSite *iface,
                                                      REFIID riid, void **ppv)
 {
-    WebBrowser *This = DOCSITE_THIS(iface);
+    DocHost *This = DOCSITE_THIS(iface);
     return IOleClientSite_QueryInterface(CLIENTSITE(This), riid, ppv);
 }
 
 static ULONG WINAPI OleDocumentSite_AddRef(IOleDocumentSite *iface)
 {
-    WebBrowser *This = DOCSITE_THIS(iface);
+    DocHost *This = DOCSITE_THIS(iface);
     return IOleClientSite_AddRef(CLIENTSITE(This));
 }
 
 static ULONG WINAPI OleDocumentSite_Release(IOleDocumentSite *iface)
 {
-    WebBrowser *This = DOCSITE_THIS(iface);
+    DocHost *This = DOCSITE_THIS(iface);
     return IOleClientSite_Release(CLIENTSITE(This));
 }
 
 static HRESULT WINAPI OleDocumentSite_ActivateMe(IOleDocumentSite *iface,
                                                  IOleDocumentView *pViewToActivate)
 {
-    WebBrowser *This = DOCSITE_THIS(iface);
+    DocHost *This = DOCSITE_THIS(iface);
     IOleDocument *oledoc;
     RECT rect;
     HRESULT hres;
@@ -320,7 +337,7 @@
     IOleDocument_CreateView(oledoc, INPLACESITE(This), NULL, 0, &This->view);
     IOleDocument_Release(oledoc);
 
-    GetClientRect(This->doc_view_hwnd, &rect);
+    GetClientRect(This->hwnd, &rect);
     IOleDocumentView_SetRect(This->view, &rect);
 
     hres = IOleDocumentView_Show(This->view, TRUE);
@@ -337,16 +354,176 @@
     OleDocumentSite_ActivateMe
 };
 
-void WebBrowser_ClientSite_Init(WebBrowser *This)
+#define DISP_THIS(iface) DEFINE_THIS(DocHost, Dispatch, iface)
+
+static HRESULT WINAPI ClDispatch_QueryInterface(IDispatch *iface, REFIID riid, void **ppv)
 {
+    DocHost *This = DISP_THIS(iface);
+    return IOleClientSite_QueryInterface(CLIENTSITE(This), riid, ppv);
+}
+
+static ULONG WINAPI ClDispatch_AddRef(IDispatch *iface)
+{
+    DocHost *This = DISP_THIS(iface);
+    return IOleClientSite_AddRef(CLIENTSITE(This));
+}
+
+static ULONG WINAPI ClDispatch_Release(IDispatch *iface)
+{
+    DocHost *This = DISP_THIS(iface);
+    return IOleClientSite_Release(CLIENTSITE(This));
+}
+
+static HRESULT WINAPI ClDispatch_GetTypeInfoCount(IDispatch *iface, UINT *pctinfo)
+{
+    DocHost *This = DISP_THIS(iface);
+
+    TRACE("(%p)->(%p)\n", This, pctinfo);
+
+    return E_NOTIMPL;
+}
+
+static HRESULT WINAPI ClDispatch_GetTypeInfo(IDispatch *iface, UINT iTInfo, LCID lcid,
+                                             ITypeInfo **ppTInfo)
+{
+    DocHost *This = DISP_THIS(iface);
+
+    TRACE("(%p)->(%u %d %p)\n", This, iTInfo, lcid, ppTInfo);
+
+    return E_NOTIMPL;
+}
+
+static HRESULT WINAPI ClDispatch_GetIDsOfNames(IDispatch *iface, REFIID riid, LPOLESTR *rgszNames,
+                                               UINT cNames, LCID lcid, DISPID *rgDispId)
+{
+    DocHost *This = DISP_THIS(iface);
+
+    TRACE("(%p)->(%s %p %u %d %p)\n", This, debugstr_guid(riid), rgszNames, cNames,
+          lcid, rgDispId);
+
+    return E_NOTIMPL;
+}
+
+static const char *debugstr_dispid(DISPID dispid)
+{
+    static char buf[16];
+
+#define CASE_DISPID(did) case did: return #did
+    switch(dispid) {
+        CASE_DISPID(DISPID_AMBIENT_USERMODE);
+        CASE_DISPID(DISPID_AMBIENT_DLCONTROL);
+        CASE_DISPID(DISPID_AMBIENT_USERAGENT);
+        CASE_DISPID(DISPID_AMBIENT_PALETTE);
+        CASE_DISPID(DISPID_AMBIENT_OFFLINEIFNOTCONNECTED);
+        CASE_DISPID(DISPID_AMBIENT_SILENT);
+    }
+#undef CASE_DISPID
+
+    sprintf(buf, "%ld", dispid);
+    return buf;
+}
+
+static HRESULT WINAPI ClDispatch_Invoke(IDispatch *iface, DISPID dispIdMember, REFIID riid,
+                                        LCID lcid, WORD wFlags, DISPPARAMS *pDispParams,
+                                        VARIANT *pVarResult, EXCEPINFO *pExcepInfo, UINT *puArgErr)
+{
+    DocHost *This = DISP_THIS(iface);
+
+    TRACE("(%p)->(%s %s %d %04x %p %p %p %p)\n", This, debugstr_dispid(dispIdMember),
+          debugstr_guid(riid), lcid, wFlags, pDispParams, pVarResult, pExcepInfo, puArgErr);
+
+    switch(dispIdMember) {
+    case DISPID_AMBIENT_USERMODE:
+    case DISPID_AMBIENT_DLCONTROL:
+    case DISPID_AMBIENT_USERAGENT:
+    case DISPID_AMBIENT_PALETTE:
+        if(!This->client_disp)
+            return E_FAIL;
+        return IDispatch_Invoke(This->client_disp, dispIdMember, riid, lcid, wFlags,
+                                pDispParams, pVarResult, pExcepInfo, puArgErr);
+    case DISPID_AMBIENT_OFFLINEIFNOTCONNECTED:
+        V_VT(pVarResult) = VT_BOOL;
+        V_BOOL(pVarResult) = This->offline;
+        return S_OK;
+    case DISPID_AMBIENT_SILENT:
+        V_VT(pVarResult) = VT_BOOL;
+        V_BOOL(pVarResult) = This->offline;
+        return S_OK;
+    }
+
+    FIXME("unhandled dispid %d\n", dispIdMember);
+    return E_NOTIMPL;
+}
+
+#undef DISP_THIS
+
+static const IDispatchVtbl DispatchVtbl = {
+    ClDispatch_QueryInterface,
+    ClDispatch_AddRef,
+    ClDispatch_Release,
+    ClDispatch_GetTypeInfoCount,
+    ClDispatch_GetTypeInfo,
+    ClDispatch_GetIDsOfNames,
+    ClDispatch_Invoke
+};
+
+#define SERVPROV_THIS(iface) DEFINE_THIS(DocHost, ServiceProvider, iface)
+
+static HRESULT WINAPI ClServiceProvider_QueryInterface(IServiceProvider *iface, REFIID riid,
+                                                       void **ppv)
+{
+    DocHost *This = SERVPROV_THIS(iface);
+    return IOleClientSite_QueryInterface(CLIENTSITE(This), riid, ppv);
+}
+
+static ULONG WINAPI ClServiceProvider_AddRef(IServiceProvider *iface)
+{
+    DocHost *This = SERVPROV_THIS(iface);
+    return IOleClientSite_AddRef(CLIENTSITE(This));
+}
+
+static ULONG WINAPI ClServiceProvider_Release(IServiceProvider *iface)
+{
+    DocHost *This = SERVPROV_THIS(iface);
+    return IOleClientSite_Release(CLIENTSITE(This));
+}
+
+static HRESULT WINAPI ClServiceProvider_QueryService(IServiceProvider *iface, REFGUID guidService,
+                                                     REFIID riid, void **ppv)
+{
+    DocHost *This = SERVPROV_THIS(iface);
+
+    if(IsEqualGUID(&IID_IHlinkFrame, guidService)) {
+        TRACE("(%p)->(IID_IHlinkFrame %s %p)\n", This, debugstr_guid(riid), ppv);
+        return IDispatch_QueryInterface(This->disp, riid, ppv);
+    }
+
+    FIXME("(%p)->(%s %s %p)\n", This, debugstr_guid(guidService), debugstr_guid(riid), ppv);
+
+    return E_NOINTERFACE;
+}
+
+#undef SERVPROV_THIS
+
+static const IServiceProviderVtbl ServiceProviderVtbl = {
+    ClServiceProvider_QueryInterface,
+    ClServiceProvider_AddRef,
+    ClServiceProvider_Release,
+    ClServiceProvider_QueryService
+};
+
+void DocHost_ClientSite_Init(DocHost *This)
+{
     This->lpOleClientSiteVtbl   = &OleClientSiteVtbl;
     This->lpOleInPlaceSiteVtbl  = &OleInPlaceSiteVtbl;
     This->lpOleDocumentSiteVtbl = &OleDocumentSiteVtbl;
+    This->lpDispatchVtbl        = &DispatchVtbl;
+    This->lpServiceProviderVtbl = &ServiceProviderVtbl;
 
     This->view = NULL;
 }
 
-void WebBrowser_ClientSite_Destroy(WebBrowser *This)
+void DocHost_ClientSite_Release(DocHost *This)
 {
     if(This->view)
         IOleDocumentView_Release(This->view);
Index: dll/win32/shdocvw/classinfo.c
===================================================================
--- dll/win32/shdocvw/classinfo.c	(Revision 31635)
+++ dll/win32/shdocvw/classinfo.c	(Arbeitskopie)
@@ -15,7 +15,7 @@
  *
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
  */
 
 #include <stdarg.h>
@@ -70,24 +70,19 @@
 {
     WebBrowser *This = CLASSINFO_THIS(iface);
 
-    FIXME("(%p)->(%ld %p)\n", This, dwGuidKind, pGUID);
+    TRACE("(%p)->(%ld %p)\n", This, dwGuidKind, pGUID);
 
-    if (dwGuidKind != GUIDKIND_DEFAULT_SOURCE_DISP_IID)
-    {
-        FIXME ("Requested unsupported GUID type: %ld\n", dwGuidKind);
-        return E_FAIL;  /* Is there a better return type here? */
+    if(!pGUID)
+        return E_POINTER;
+
+    if (dwGuidKind != GUIDKIND_DEFAULT_SOURCE_DISP_IID) {
+        WARN("Wrong GUID type: %d\n", dwGuidKind);
+        memcpy(pGUID, &IID_NULL, sizeof(GUID));
+        return E_FAIL;
     }
 
-    /* FIXME: Returning IPropertyNotifySink interface, but should really
-     * return a more generic event set (???) dispinterface.
-     * However, this hack, allows a control site to return with success
-     * (MFC's COleControlSite falls back to older IProvideClassInfo interface
-     * if GetGUID() fails to return a non-NULL GUID).
-     */
-    memcpy(pGUID, &IID_IPropertyNotifySink, sizeof(GUID));
-    FIXME("Wrongly returning IPropertyNotifySink interface %s\n",
-          debugstr_guid(pGUID));
-
+    memcpy(pGUID, This->version == 1 ? &DIID_DWebBrowserEvents : &DIID_DWebBrowserEvents2,
+           sizeof(GUID));
     return S_OK;
 }
 
Index: dll/win32/shdocvw/iexplore.c
===================================================================
--- dll/win32/shdocvw/iexplore.c	(Revision 0)
+++ dll/win32/shdocvw/iexplore.c	(Revision 0)
@@ -0,0 +1,231 @@
+/*
+ * SHDOCVW - Internet Explorer main frame window
+ *
+ * Copyright 2006 Mike McCormack (for CodeWeavers)
+ * Copyright 2006 Jacek Caban (for CodeWeavers)
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
+ */
+
+#define COBJMACROS
+
+#include <stdarg.h>
+#include "windef.h"
+#include "winbase.h"
+#include "winuser.h"
+#include "wingdi.h"
+#include "winnls.h"
+#include "ole2.h"
+#include "exdisp.h"
+#include "oleidl.h"
+
+#include "shdocvw.h"
+
+#include "wine/debug.h"
+
+WINE_DEFAULT_DEBUG_CHANNEL(shdocvw);
+
+static const WCHAR szIEWinFrame[] = { 'I','E','F','r','a','m','e',0 };
+
+static LRESULT iewnd_OnCreate(HWND hwnd, LPCREATESTRUCTW lpcs)
+{
+    SetWindowLongPtrW(hwnd, 0, (LONG_PTR) lpcs->lpCreateParams);
+    return 0;
+}
+
+static LRESULT iewnd_OnSize(InternetExplorer *This, INT width, INT height)
+{
+    if(This->doc_host.hwnd)
+        SetWindowPos(This->doc_host.hwnd, NULL, 0, 0, width, height,
+                     SWP_NOZORDER | SWP_NOACTIVATE);
+
+    return 0;
+}
+
+static LRESULT iewnd_OnDestroy(InternetExplorer *This)
+{
+    TRACE("%p\n", This);
+
+    This->frame_hwnd = NULL;
+    PostQuitMessage(0); /* FIXME */
+
+    return 0;
+}
+
+static LRESULT CALLBACK
+ie_window_proc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
+{
+    InternetExplorer *This = (InternetExplorer*) GetWindowLongPtrW(hwnd, 0);
+
+    switch (msg)
+    {
+    case WM_CREATE:
+        return iewnd_OnCreate(hwnd, (LPCREATESTRUCTW)lparam);
+    case WM_DESTROY:
+        return iewnd_OnDestroy(This);
+    case WM_SIZE:
+        return iewnd_OnSize(This, LOWORD(lparam), HIWORD(lparam));
+    }
+    return DefWindowProcW(hwnd, msg, wparam, lparam);
+}
+
+void register_iewindow_class(void)
+{
+    WNDCLASSW wc;
+
+    memset(&wc, 0, sizeof wc);
+    wc.style = 0;
+    wc.lpfnWndProc = ie_window_proc;
+    wc.cbClsExtra = 0;
+    wc.cbWndExtra = sizeof(InternetExplorer*);
+    wc.hInstance = shdocvw_hinstance;
+    wc.hIcon = 0;
+    wc.hCursor = LoadCursorW(0, MAKEINTRESOURCEW(IDI_APPLICATION));
+    wc.hbrBackground = 0;
+    wc.lpszClassName = szIEWinFrame;
+    wc.lpszMenuName = NULL;
+
+    RegisterClassW(&wc);
+}
+
+void unregister_iewindow_class(void)
+{
+    UnregisterClassW(szIEWinFrame, shdocvw_hinstance);
+}
+
+static void create_frame_hwnd(InternetExplorer *This)
+{
+    /* Windows uses "Microsoft Internet Explorer" */
+    static const WCHAR wszWineInternetExplorer[] =
+        {'W','i','n','e',' ','I','n','t','e','r','n','e','t',' ','E','x','p','l','o','r','e','r',0};
+
+    This->frame_hwnd = CreateWindowExW(
+            WS_EX_WINDOWEDGE,
+            szIEWinFrame, wszWineInternetExplorer,
+            WS_CLIPCHILDREN | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME
+                | WS_MINIMIZEBOX | WS_MAXIMIZEBOX,
+            CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
+            NULL, NULL /* FIXME */, shdocvw_hinstance, This);
+}
+
+static IWebBrowser2 *create_ie_window(LPCSTR cmdline)
+{
+    IWebBrowser2 *wb = NULL;
+
+    InternetExplorer_Create(NULL, &IID_IWebBrowser2, (void**)&wb);
+    if(!wb)
+        return NULL;
+
+    IWebBrowser2_put_Visible(wb, VARIANT_TRUE);
+
+    if(!*cmdline) {
+        IWebBrowser2_GoHome(wb);
+    }else {
+        VARIANT var_url;
+        DWORD len;
+
+        if(!strncasecmp(cmdline, "-nohome", 7))
+            cmdline += 7;
+
+        V_VT(&var_url) = VT_BSTR;
+
+        len = MultiByteToWideChar(CP_ACP, 0, cmdline, -1, NULL, 0);
+        V_BSTR(&var_url) = SysAllocStringLen(NULL, len);
+        MultiByteToWideChar(CP_ACP, 0, cmdline, -1, V_BSTR(&var_url), len);
+
+        /* navigate to the first page */
+        IWebBrowser2_Navigate2(wb, &var_url, NULL, NULL, NULL, NULL);
+
+        SysFreeString(V_BSTR(&var_url));
+    }
+
+    return wb;
+}
+
+HRESULT InternetExplorer_Create(IUnknown *pOuter, REFIID riid, void **ppv)
+{
+    InternetExplorer *ret;
+    HRESULT hres;
+
+    TRACE("(%p %s %p)\n", pOuter, debugstr_guid(riid), ppv);
+
+    ret = HeapAlloc(GetProcessHeap(), 0, sizeof(InternetExplorer));
+    ret->ref = 0;
+
+    ret->doc_host.disp = (IDispatch*)WEBBROWSER2(ret);
+    DocHost_Init(&ret->doc_host, (IDispatch*)WEBBROWSER2(ret));
+
+    InternetExplorer_WebBrowser_Init(ret);
+
+    create_frame_hwnd(ret);
+    ret->doc_host.frame_hwnd = ret->frame_hwnd;
+
+    hres = IWebBrowser2_QueryInterface(WEBBROWSER2(ret), riid, ppv);
+    if(FAILED(hres)) {
+        HeapFree(GetProcessHeap(), 0, ret);
+        return hres;
+    }
+
+    return hres;
+}
+
+/******************************************************************
+ *		IEWinMain            (SHDOCVW.101)
+ *
+ * Only returns on error.
+ */
+DWORD WINAPI IEWinMain(LPSTR szCommandLine, int nShowWindow)
+{
+    IWebBrowser2 *wb = NULL;
+    MSG msg;
+    HRESULT hres;
+
+    TRACE("%s %d\n", debugstr_a(szCommandLine), nShowWindow);
+
+    if(*szCommandLine == '-' || *szCommandLine == '/') {
+        if(!strcasecmp(szCommandLine+1, "regserver"))
+            return register_iexplore(TRUE);
+        if(!strcasecmp(szCommandLine+1, "unregserver"))
+            return register_iexplore(FALSE);
+    }
+
+    CoInitialize(NULL);
+
+    hres = register_class_object(TRUE);
+    if(FAILED(hres)) {
+        CoUninitialize();
+        ExitProcess(1);
+    }
+
+    if(strcasecmp(szCommandLine, "-embedding"))
+        wb = create_ie_window(szCommandLine);
+
+    /* run the message loop for this thread */
+    while (GetMessageW(&msg, 0, 0, 0))
+    {
+        TranslateMessage(&msg);
+        DispatchMessageW(&msg);
+    }
+
+    if(wb)
+        IWebBrowser2_Release(wb);
+
+    register_class_object(FALSE);
+
+    CoUninitialize();
+
+    ExitProcess(0);
+    return 0;
+}
Index: dll/win32/shdocvw/shdocvw.rc
===================================================================
--- dll/win32/shdocvw/shdocvw.rc	(Revision 31635)
+++ dll/win32/shdocvw/shdocvw.rc	(Arbeitskopie)
@@ -13,7 +13,7 @@
  *
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
  */
 
 #include "windef.h"
@@ -39,3 +39,6 @@
 #include "Ru.rc"
 #include "Sv.rc"
 #include "Uk.rc"
+
+/* @makedep: shdocvw.inf */
+REGINST REGINST shdocvw.inf
Index: dll/win32/shdocvw/events.c
===================================================================
--- dll/win32/shdocvw/events.c	(Revision 31635)
+++ dll/win32/shdocvw/events.c	(Arbeitskopie)
@@ -5,6 +5,7 @@
  *  - IConnectionPoint
  *
  * Copyright 2001 John R. Sheets (for CodeWeavers)
+ * Copyright 2006 Jacek Caban for CodeWeavers
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Lesser General Public
@@ -18,7 +19,7 @@
  *
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
  */
 
 #include <string.h>
@@ -30,7 +31,7 @@
 struct ConnectionPoint {
     const IConnectionPointVtbl *lpConnectionPointVtbl;
 
-    WebBrowser *webbrowser;
+    IConnectionPointContainer *container;
 
     IDispatch **sinks;
     DWORD sinks_size;
@@ -44,31 +45,31 @@
  * Implement the IConnectionPointContainer interface
  */
 
-#define CONPTCONT_THIS(iface) DEFINE_THIS(WebBrowser, ConnectionPointContainer, iface)
+#define CONPTCONT_THIS(iface) DEFINE_THIS(ConnectionPointContainer, ConnectionPointContainer, iface)
 
 static HRESULT WINAPI ConnectionPointContainer_QueryInterface(IConnectionPointContainer *iface,
-        REFIID riid, LPVOID *ppobj)
+        REFIID riid, LPVOID *ppv)
 {
-    WebBrowser *This = CONPTCONT_THIS(iface);
-    return IWebBrowser_QueryInterface(WEBBROWSER(This), riid, ppobj);
+    ConnectionPointContainer *This = CONPTCONT_THIS(iface);
+    return IUnknown_QueryInterface(This->impl, riid, ppv);
 }
 
 static ULONG WINAPI ConnectionPointContainer_AddRef(IConnectionPointContainer *iface)
 {
-    WebBrowser *This = CONPTCONT_THIS(iface);
-    return IWebBrowser_AddRef(WEBBROWSER(This));
+    ConnectionPointContainer *This = CONPTCONT_THIS(iface);
+    return IUnknown_AddRef(This->impl);
 }
 
 static ULONG WINAPI ConnectionPointContainer_Release(IConnectionPointContainer *iface)
 {
-    WebBrowser *This = CONPTCONT_THIS(iface);
-    return IWebBrowser_Release(WEBBROWSER(This));
+    ConnectionPointContainer *This = CONPTCONT_THIS(iface);
+    return IUnknown_Release(This->impl);
 }
 
 static HRESULT WINAPI ConnectionPointContainer_EnumConnectionPoints(IConnectionPointContainer *iface,
         LPENUMCONNECTIONPOINTS *ppEnum)
 {
-    WebBrowser *This = CONPTCONT_THIS(iface);
+    ConnectionPointContainer *This = CONPTCONT_THIS(iface);
     FIXME("(%p)->(%p)\n", This, ppEnum);
     return E_NOTIMPL;
 }
@@ -76,7 +77,7 @@
 static HRESULT WINAPI ConnectionPointContainer_FindConnectionPoint(IConnectionPointContainer *iface,
         REFIID riid, LPCONNECTIONPOINT *ppCP)
 {
-    WebBrowser *This = CONPTCONT_THIS(iface);
+    ConnectionPointContainer *This = CONPTCONT_THIS(iface);
 
     if(!ppCP) {
         WARN("ppCP == NULL\n");
@@ -87,13 +88,13 @@
 
     if(IsEqualGUID(&DIID_DWebBrowserEvents2, riid)) {
         TRACE("(%p)->(DIID_DWebBrowserEvents2 %p)\n", This, ppCP);
-        *ppCP = CONPOINT(This->cp_wbe2);
+        *ppCP = CONPOINT(This->wbe2);
     }else if(IsEqualGUID(&DIID_DWebBrowserEvents, riid)) {
         TRACE("(%p)->(DIID_DWebBrowserEvents %p)\n", This, ppCP);
-        *ppCP = CONPOINT(This->cp_wbe);
+        *ppCP = CONPOINT(This->wbe);
     }else if(IsEqualGUID(&IID_IPropertyNotifySink, riid)) {
         TRACE("(%p)->(IID_IPropertyNotifySink %p)\n", This, ppCP);
-        *ppCP = CONPOINT(This->cp_pns);
+        *ppCP = CONPOINT(This->pns);
     }
 
     if(*ppCP) {
@@ -102,7 +103,7 @@
     }
 
     WARN("Unsupported IID %s\n", debugstr_guid(riid));
-    return E_NOINTERFACE;
+    return CONNECT_E_NOCONNECTION;
 }
 
 #undef CONPTCONT_THIS
@@ -139,7 +140,7 @@
     }
 
     if(*ppv) {
-        IWebBrowser2_AddRef(WEBBROWSER(This->webbrowser));
+        IConnectionPointContainer_AddRef(This->container);
         return S_OK;
     }
 
@@ -150,13 +151,13 @@
 static ULONG WINAPI ConnectionPoint_AddRef(IConnectionPoint *iface)
 {
     ConnectionPoint *This = CONPOINT_THIS(iface);
-    return IWebBrowser2_AddRef(WEBBROWSER(This->webbrowser));
+    return IConnectionPointContainer_AddRef(This->container);
 }
 
 static ULONG WINAPI ConnectionPoint_Release(IConnectionPoint *iface)
 {
     ConnectionPoint *This = CONPOINT_THIS(iface);
-    return IWebBrowser2_Release(WEBBROWSER(This->webbrowser));
+    return IConnectionPointContainer_Release(This->container);
 }
 
 static HRESULT WINAPI ConnectionPoint_GetConnectionInterface(IConnectionPoint *iface, IID *pIID)
@@ -176,7 +177,8 @@
 
     TRACE("(%p)->(%p)\n", This, ppCPC);
 
-    *ppCPC = CONPTCONT(This->webbrowser);
+    *ppCPC = This->container;
+    IConnectionPointContainer_AddRef(This->container);
     return S_OK;
 }
 
@@ -266,15 +268,16 @@
     }
 }
 
-static void ConnectionPoint_Create(WebBrowser *wb, REFIID riid, ConnectionPoint **cp)
+static void ConnectionPoint_Create(REFIID riid, ConnectionPoint **cp,
+                                   IConnectionPointContainer *container)
 {
     ConnectionPoint *ret = HeapAlloc(GetProcessHeap(), 0, sizeof(ConnectionPoint));
 
     ret->lpConnectionPointVtbl = &ConnectionPointVtbl;
-    ret->webbrowser = wb;
 
     ret->sinks = NULL;
     ret->sinks_size = 0;
+    ret->container = container;
 
     memcpy(&ret->iid, riid, sizeof(IID));
 
@@ -294,18 +297,20 @@
     HeapFree(GetProcessHeap(), 0, This);
 }
 
-void WebBrowser_Events_Init(WebBrowser *This)
+void ConnectionPointContainer_Init(ConnectionPointContainer *This, IUnknown *impl)
 {
     This->lpConnectionPointContainerVtbl = &ConnectionPointContainerVtbl;
 
-    ConnectionPoint_Create(This, &DIID_DWebBrowserEvents2, &This->cp_wbe2);
-    ConnectionPoint_Create(This, &DIID_DWebBrowserEvents, &This->cp_wbe);
-    ConnectionPoint_Create(This, &IID_IPropertyNotifySink, &This->cp_pns);
+    ConnectionPoint_Create(&DIID_DWebBrowserEvents2, &This->wbe2, CONPTCONT(This));
+    ConnectionPoint_Create(&DIID_DWebBrowserEvents,  &This->wbe,  CONPTCONT(This));
+    ConnectionPoint_Create(&IID_IPropertyNotifySink, &This->pns,  CONPTCONT(This));
+
+    This->impl = impl;
 }
 
-void WebBrowser_Events_Destroy(WebBrowser *This)
+void ConnectionPointContainer_Destroy(ConnectionPointContainer *This)
 {
-    ConnectionPoint_Destroy(This->cp_wbe2);
-    ConnectionPoint_Destroy(This->cp_wbe);
-    ConnectionPoint_Destroy(This->cp_pns);
+    ConnectionPoint_Destroy(This->wbe2);
+    ConnectionPoint_Destroy(This->wbe);
+    ConnectionPoint_Destroy(This->pns);
 }
